//#extension GL_EXT_gpu_shader4 : enable

uniform sampler2D textureImage;

uniform float projMatrix10;
uniform float projMatrix14;
uniform float depthMax;

void main (void)
{
    vec2 texCoord = gl_TexCoord[0].st;

    vec4 texColor = texture2D(textureImage, texCoord);

    int perspective = 1;
    if (projMatrix14 == 0) perspective = 0;
    // ̔Zindaiji ł͂Ȃ悤 near  far 𒲐Ă邩

    // [0 to 1]  [-1 to 1] ̃Wɕϊ
    // Prjcetion Matrix ł̕ϊ [-1 to 1] 
    float z_eye = (texColor[0] * 2 - 1);

    if (perspective == 1)
	z_eye = projMatrix14 / (z_eye + projMatrix10);
    else
	z_eye =  - (z_eye - projMatrix14 ) / projMatrix10;
    
    //z_eye = -z_eye;

    z_eye /= depthMax;

    gl_FragColor[0] = z_eye;
    gl_FragColor[1] = z_eye;
    gl_FragColor[2] = z_eye;
    gl_FragColor[3] = 1;

    return;
}
